diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSponge.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index 37a3a523a..ae5ae401e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -9,12 +9,12 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockSponge extends Block
+public class BlockLogicSponge extends BlockLogic
 {
     final boolean isWet;
-	public BlockSponge(String key, String namespaceId, int id, boolean isWet)
+	public BlockLogicSponge(Block<?> block, boolean isWet)
     {
-        super(key, namespaceId, id, Material.sponge);
+        super(block, Material.sponge);
         this.isWet = isWet;
     }
 
@@ -23,8 +23,8 @@ public class BlockSponge extends Block
     {
         super.onBlockPlacedByWorld(world, x, y, z);
         byte byte0 = 2;
-        if(world.dimension.id == Dimension.NETHER.id && isWet){
-            world.setBlockWithNotify(x, y, z, Blocks.SPONGE_DRY.id);
+        if(world.dimension == Dimension.NETHER && isWet){
+            world.setBlockWithNotify(x, y, z, Blocks.SPONGE_DRY.id());
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for(int l = 0; l < 8; l++)
             {
@@ -35,30 +35,30 @@ public class BlockSponge extends Block
             for (int l = x - byte0; l <= x + byte0; l++) {
                 for (int i1 = y - byte0; i1 <= y + byte0; i1++) {
                     for (int j1 = z - byte0; j1 <= z + byte0; j1++) {
-                        if (Block.hasTag(world.getBlockId(l, i1, j1), BlockTags.IS_WATER)) {
+                        if (Blocks.hasTag(world.getBlockId(l, i1, j1), BlockTags.IS_WATER)) {
                             world.setBlockWithNotify(l, i1, j1, 0);
 
                         }
                     }
                 }
             }
-            world.setBlockWithNotify(x, y, z, Blocks.SPONGE_WET.id);
+            world.setBlockWithNotify(x, y, z, Blocks.SPONGE_WET.id());
         }
     }
 
 
     public boolean inWater(World world, int x, int y, int z){
-        if (Block.hasTag(world.getBlockId(x + 1, y, z), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x + 1, y, z), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x - 1, y, z), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x - 1, y, z), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y + 1, z), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y , z + 1), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x, y , z + 1), BlockTags.IS_WATER))
             return true;
-        if (Block.hasTag(world.getBlockId(x, y , z - 1), BlockTags.IS_WATER))
+        if (Blocks.hasTag(world.getBlockId(x, y , z - 1), BlockTags.IS_WATER))
             return true;
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
similarity index 92%
rename from game/core/src/main/java/net/minecraft/core/block/BlockStairs.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index d2c46316f..d17029996 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -4,6 +4,7 @@ import java.util.ArrayList;
 import java.util.Random;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -18,7 +19,7 @@ import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockStairs extends Block
+public class BlockLogicStairs extends BlockLogic
 {
 //    private static final Map<Integer, BoundingVolume> selectionVolumes = new HashMap<>();
 //
@@ -81,13 +82,20 @@ public class BlockStairs extends Block
 //        selectionVolumes.put(0b1011, vol);
 //    }
 
-	public BlockStairs(Block block, String namespaceId, int id)
+    public Block<?> modelBlock;
+
+	public BlockLogicStairs(Block<?> block, Block<?> modelBlock)
     {
-        super("stairs." + block.key.substring(5), namespaceId, id, block.blockMaterial);
-        modelBlock = block;
-        withHardness(block.blockHardness);
-        withBlastResistance(block.blastResistance / 3F);
-        withLightBlock(255);
+        super(block, Material.stone);
+        this.modelBlock = modelBlock;
+        block.withHardness(block.blockHardness);
+        block.withBlastResistance(block.blastResistance / 3F);
+        block.withLightBlock(255);
+    }
+
+    @Override
+    public @NotNull Material getMaterial() {
+        return modelBlock.getMaterial();
     }
 
     @Override
@@ -101,7 +109,7 @@ public class BlockStairs extends Block
     {
         return false;
     }
-    
+
     @Override
     public boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z) {
     	return (world.getBlockMetadata(x, y, z) & 8) > 0;
@@ -145,10 +153,10 @@ public class BlockStairs extends Block
         {
             for (ItemStack stack : result)
             {
-                if (stack.itemID == modelBlock.id)
+                if (stack.itemID == modelBlock.id())
                 {
                     stack.setMetadata(meta & 0xF0);
-                    stack.itemID = this.id;
+                    stack.itemID = this.id();
                 }
             }
         }
@@ -165,10 +173,10 @@ public class BlockStairs extends Block
         {
             for (ItemStack stack : result)
             {
-                if (stack.itemID == modelBlock.id)
+                if (stack.itemID == modelBlock.id())
                 {
                     stack.setMetadata(meta & 0xF0);
-                    stack.itemID = this.id;
+                    stack.itemID = this.id();
                 }
             }
         }
@@ -205,7 +213,6 @@ public class BlockStairs extends Block
     {
         return modelBlock.tickDelay();
     }
-
 //    @Override
 //    public BoundingVolume getBoundingVolume(World world, int x, int y, int z)
 //    {
@@ -213,6 +220,7 @@ public class BlockStairs extends Block
 //        return selectionVolumes.getOrDefault(meta & 0x0F, null);
 //    }
 
+
     @Override
     public void handleEntityInside(World world, int x, int y, int z, Entity entity, Vec3 entityVelocity)
     {
@@ -267,11 +275,11 @@ public class BlockStairs extends Block
     {
         modelBlock.onBlockDestroyedByExplosion(world, x, y, z);
     }
-    
+
     @Override
     public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
 //    	System.out.println("Placed Side: "+side+" Height: "+sideHeight);
-    	
+
         int meta = world.getBlockMetadata(x, y, z) & 0xF0;
 
         Direction hRotation = mob.getHorizontalPlacementDirection(side).getOpposite();
@@ -311,10 +319,8 @@ public class BlockStairs extends Block
     public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
     	return 0.0f;
     }
-
     @Override
-    public MaterialColor getMaterialColor(){
+    public @NotNull MaterialColor getMaterialColor(){
         return modelBlock.getMaterialColor();
     }
-    public Block modelBlock;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockStairsPaintable.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
similarity index 53%
rename from game/core/src/main/java/net/minecraft/core/block/BlockStairsPaintable.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
index 833b05b3f..b1c8de1a1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockStairsPaintable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPaintable.java
@@ -3,15 +3,15 @@ package net.minecraft.core.block;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
-public class BlockStairsPaintable extends BlockStairs implements IPaintable {
-    public BlockStairsPaintable(Block block, String namespaceId, int id) {
-        super(block, namespaceId, id);
+public class BlockLogicStairsPaintable extends BlockLogicStairs implements IPaintable {
+    public BlockLogicStairsPaintable(Block<?> block, Block<?> modelBlock) {
+        super(block, modelBlock);
     }
 
     @Override
     public void setColor(World world, int x, int y, int z, DyeColor color) {
         final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadata(x, y, z, Blocks.STAIRS_PLANKS_PAINTED.id, meta);
-        ((IPaintable) Blocks.STAIRS_PLANKS_PAINTED).setColor(world, x, y, z, color);
+        world.setBlockAndMetadata(x, y, z, Blocks.STAIRS_PLANKS_PAINTED.id(), meta);
+        Blocks.STAIRS_PLANKS_PAINTED.getLogic().setColor(world, x, y, z, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockStairsPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
similarity index 77%
rename from game/core/src/main/java/net/minecraft/core/block/BlockStairsPainted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
index 3f15f550e..ee1966f1a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockStairsPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairsPainted.java
@@ -3,9 +3,9 @@ package net.minecraft.core.block;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
-public class BlockStairsPainted extends BlockStairs implements IPainted {
-    public BlockStairsPainted(Block block, String namespaceId, int id) {
-        super(block, namespaceId, id);
+public class BlockLogicStairsPainted extends BlockLogicStairs implements IPainted {
+    public BlockLogicStairsPainted(Block<?> block, Block<?> modelBlock) {
+        super(block, modelBlock);
     }
 
     @Override
@@ -26,7 +26,7 @@ public class BlockStairsPainted extends BlockStairs implements IPainted {
     @Override
     public void removeDye(World world, int x, int y, int z) {
         final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.STAIRS_PLANKS_OAK.id, stripColorFromMetadata(meta));
+        world.setBlockAndMetadataWithNotify(x, y, z, Blocks.STAIRS_PLANKS_OAK.id(), stripColorFromMetadata(meta));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockStone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
similarity index 81%
rename from game/core/src/main/java/net/minecraft/core/block/BlockStone.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
index 8b3559dff..2649185b6 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockStone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStone.java
@@ -11,15 +11,14 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.chunk.Chunk;
 
 import java.util.Random;
-import java.util.function.Supplier;
 
-public class BlockStone extends Block {
+public class BlockLogicStone extends BlockLogic {
 
-	private final Supplier<Block> cobblestoneSupplier;
+	private final Block<?> cobble;
 
-	public BlockStone(String key, String namespaceId, int id, Supplier<Block> cobbleStoneSupplier, Material material) {
-		super(key, namespaceId, id, material);
-		this.cobblestoneSupplier = cobbleStoneSupplier;
+	public BlockLogicStone(Block<?> block, Block<?> cobbleStone, Material material) {
+		super(block, material);
+		this.cobble = cobbleStone;
 	}
 
 	@Override
@@ -56,7 +55,7 @@ public class BlockStone extends Block {
 			case WORLD:
 			case EXPLOSION:
 			case PROPER_TOOL:
-				return new ItemStack[] { new ItemStack(cobblestoneSupplier.get()) };
+				return new ItemStack[] { new ItemStack(cobble) };
 			case PICK_BLOCK:
 			case SILK_TOUCH:
 				return new ItemStack[] { new ItemStack(this) };
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockSugarcane.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
similarity index 79%
rename from game/core/src/main/java/net/minecraft/core/block/BlockSugarcane.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
index 55af54518..c06688617 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockSugarcane.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
@@ -16,15 +16,15 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockSugarcane extends Block implements IBonemealable
+public class BlockLogicSugarcane extends BlockLogic implements IBonemealable
 {
 
-	public BlockSugarcane(String key, String namespaceId, int id)
+	public BlockLogicSugarcane(Block<?> block)
     {
-        super(key, namespaceId, id, Material.plant);
+        super(block, Material.plant);
         float f = 0.375F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 1.0F, 0.5F + f);
-        setTicking(true);
+        block.setTicking(true);
     }
 
     @Override
@@ -33,13 +33,13 @@ public class BlockSugarcane extends Block implements IBonemealable
         if(world.isAirBlock(x, y + 1, z))
         {
             int l;
-            for(l = 1; world.getBlockId(x, y - l, z) == id; l++) { }
+            for(l = 1; world.getBlockId(x, y - l, z) == id(); l++) { }
             if(l < 3)
             {
                 int i1 = world.getBlockMetadata(x, y, z);
                 if(i1 == 15)
                 {
-                    world.setBlockWithNotify(x, y + 1, z, id);
+                    world.setBlockWithNotify(x, y + 1, z, id());
                     world.setBlockMetadataWithNotify(x, y, z, 0);
                 } else
                 {
@@ -51,9 +51,9 @@ public class BlockSugarcane extends Block implements IBonemealable
 
     public void growReedOnTop(World world, int x, int y, int z){
             int l;
-            for(l = 1; world.getBlockId(x, y + l, z) == id; l++) { }
+            for(l = 1; world.getBlockId(x, y + l, z) == id(); l++) { }
             if(world.isAirBlock(x, y+l, z)){
-                world.setBlockWithNotify(x, y + l, z, id);
+                world.setBlockWithNotify(x, y + l, z, id());
             }
     }
 
@@ -61,7 +61,7 @@ public class BlockSugarcane extends Block implements IBonemealable
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == id)
+        if(l == id())
         {
             return true;
         }
@@ -73,19 +73,19 @@ public class BlockSugarcane extends Block implements IBonemealable
         {
             return false;
         }
-        if(Block.hasTag(world.getBlockId(x - 1, y - 1, z), BlockTags.IS_WATER))
+        if(Blocks.hasTag(world.getBlockId(x - 1, y - 1, z), BlockTags.IS_WATER))
         {
             return true;
         }
-        if(Block.hasTag(world.getBlockId(x + 1, y - 1, z), BlockTags.IS_WATER))
+        if(Blocks.hasTag(world.getBlockId(x + 1, y - 1, z), BlockTags.IS_WATER))
         {
             return true;
         }
-        if(Block.hasTag(world.getBlockId(x, y - 1, z - 1), BlockTags.IS_WATER))
+        if(Blocks.hasTag(world.getBlockId(x, y - 1, z - 1), BlockTags.IS_WATER))
         {
             return true;
         }
-        return Block.hasTag(world.getBlockId(x, y - 1, z + 1), BlockTags.IS_WATER);
+        return Blocks.hasTag(world.getBlockId(x, y - 1, z + 1), BlockTags.IS_WATER);
     }
 
     @Override
@@ -137,7 +137,7 @@ public class BlockSugarcane extends Block implements IBonemealable
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.isClientSide)
         {
-            ((BlockSugarcane)Blocks.blocksList[id]).growReedOnTop(world, blockX, blockY, blockZ);
+            growReedOnTop(world, blockX, blockY, blockZ);
             if (player == null || player.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSupplier.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSupplier.java
new file mode 100644
index 000000000..5cd03155f
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSupplier.java
@@ -0,0 +1,6 @@
+package net.minecraft.core.block;
+
+@FunctionalInterface
+public interface BlockLogicSupplier<T extends BlockLogic> {
+    T get(Block<T> b);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTNT.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
similarity index 95%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTNT.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
index 9b5d0b718..a648a7a60 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTNT.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTNT.java
@@ -10,10 +10,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
-public class BlockTNT extends Block {
+public class BlockLogicTNT extends BlockLogic {
 
-	public BlockTNT(String key, String namespaceId, int id) {
-		super(key, namespaceId, id, Material.explosive);
+	public BlockLogicTNT(Block<?> block) {
+		super(block, Material.explosive);
 	}
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTallGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTallGrass.java
similarity index 74%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTallGrass.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicTallGrass.java
index 4b74de667..ce1918d84 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTallGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTallGrass.java
@@ -6,20 +6,20 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
-public class BlockTallGrass extends BlockFlower
+public class BlockLogicTallGrass extends BlockLogicFlower
 {
-	public BlockTallGrass(String key, String namespaceId, int id)
+	public BlockLogicTallGrass(Block<?> block)
     {
-        super(key, namespaceId, id);
+        super(block);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
-        withOverrideColor(MaterialColor.grass);
+        block.withOverrideColor(MaterialColor.grass);
     }
 
     @Override
     protected boolean mayPlaceOn(int blockId) {
-    	Block block = Blocks.getBlock(blockId);
-    	if(block instanceof BlockMoss) {
+    	Block<?> block = Blocks.getBlock(blockId);
+    	if(block != null && block.getLogic() instanceof BlockLogicMoss) {
     		return true;
     	}
     	return super.mayPlaceOn(blockId);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
similarity index 92%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTorch.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index 35f06cfcf..2ff1784a7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -1,19 +1,17 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockTorch extends Block
+public class BlockLogicTorch extends BlockLogic
 {
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int SIDE_NONE = 0;
@@ -24,10 +22,10 @@ public class BlockTorch extends Block
     public static final int SIDE_BOTTOM = 5;
     public static final int SIDE_TOP = 6;
 
-	public BlockTorch(String key, String namespaceId, int id)
+	public BlockLogicTorch(Block<?> block)
     {
-        super(key, namespaceId, id, Material.decoration);
-        setTicking(true);
+        super(block, Material.decoration);
+        block.setTicking(true);
     }
 
     @Override
@@ -72,11 +70,11 @@ public class BlockTorch extends Block
     {
         int blockBelow = world.getBlockId(x, y, z);
         return world.canPlaceOnSurfaceOfBlock(x, y, z)
-            || blockBelow == Blocks.FENCE_PLANKS_OAK.id
-            || blockBelow == Blocks.FENCE_PLANKS_OAK_PAINTED.id
-            || blockBelow == Blocks.FENCE_CHAINLINK.id
-            || blockBelow == Blocks.FENCE_PAPER_WALL.id
-            || blockBelow == Blocks.FENCE_STEEL.id;
+            || blockBelow == Blocks.FENCE_PLANKS_OAK.id()
+            || blockBelow == Blocks.FENCE_PLANKS_OAK_PAINTED.id()
+            || blockBelow == Blocks.FENCE_CHAINLINK.id()
+            || blockBelow == Blocks.FENCE_PAPER_WALL.id()
+            || blockBelow == Blocks.FENCE_STEEL.id();
     }
 
     @Override
@@ -266,11 +264,11 @@ public class BlockTorch extends Block
             case SIDE_BOTTOM:
                 int blockBelow = world.getBlockId(x, y - 1, z);
                 invalid = !(world.canPlaceOnSurfaceOfBlock(x, y - 1, z)
-                    || blockBelow == Blocks.FENCE_PLANKS_OAK.id
-                    || blockBelow == Blocks.FENCE_PLANKS_OAK_PAINTED.id
-                    || blockBelow == Blocks.FENCE_CHAINLINK.id
-                    || blockBelow == Blocks.FENCE_PAPER_WALL.id
-                    || blockBelow == Blocks.FENCE_STEEL.id);
+                    || blockBelow == Blocks.FENCE_PLANKS_OAK.id()
+                    || blockBelow == Blocks.FENCE_PLANKS_OAK_PAINTED.id()
+                    || blockBelow == Blocks.FENCE_CHAINLINK.id()
+                    || blockBelow == Blocks.FENCE_PAPER_WALL.id()
+                    || blockBelow == Blocks.FENCE_STEEL.id());
                 break;
             default:
                 invalid = true;
@@ -330,6 +328,6 @@ public class BlockTorch extends Block
     
     @Override
     public int getLightmapCoord(WorldSource blockAccess, int x, int y, int z) {
-		return blockAccess.getLightmapCoord(x, y, z, Blocks.lightEmission[id] > 0 ? 15 : 0);
+		return blockAccess.getLightmapCoord(x, y, z, block.emission > 0 ? 15 : 0);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTorchRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
similarity index 80%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTorchRedstone.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
index f151e3d1e..19e7dd9b4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTorchRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorchRedstone.java
@@ -9,13 +9,13 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public class BlockTorchRedstone extends BlockTorch {
+public class BlockLogicTorchRedstone extends BlockLogicTorch {
     private final boolean torchActive;
 
-    public BlockTorchRedstone(String key, String namespaceId, int id, boolean isActive) {
-        super(key, namespaceId, id);
+    public BlockLogicTorchRedstone(Block<?> block, boolean isActive) {
+        super(block);
         torchActive = isActive;
-        setTicking(true);
+        block.setTicking(true);
     }
 
     @Override
@@ -29,24 +29,24 @@ public class BlockTorchRedstone extends BlockTorch {
             super.onBlockPlacedByWorld(world, x, y, z);
         }
         if (torchActive) {
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
-            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
-            world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-            world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-            world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
+            world.notifyBlocksOfNeighborChange(x - 1, y, z, id());
+            world.notifyBlocksOfNeighborChange(x + 1, y, z, id());
+            world.notifyBlocksOfNeighborChange(x, y, z - 1, id());
+            world.notifyBlocksOfNeighborChange(x, y, z + 1, id());
         }
     }
 
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
         if (torchActive) {
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
-            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
-            world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-            world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-            world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-            world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+            world.notifyBlocksOfNeighborChange(x, y - 1, z, id());
+            world.notifyBlocksOfNeighborChange(x, y + 1, z, id());
+            world.notifyBlocksOfNeighborChange(x - 1, y, z, id());
+            world.notifyBlocksOfNeighborChange(x + 1, y, z, id());
+            world.notifyBlocksOfNeighborChange(x, y, z - 1, id());
+            world.notifyBlocksOfNeighborChange(x, y, z + 1, id());
         }
     }
 
@@ -94,17 +94,17 @@ public class BlockTorchRedstone extends BlockTorch {
         boolean isPowered = hasNeighborSignal(world, x, y, z);
         if (torchActive) {
             if (isPowered) {
-                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TORCH_REDSTONE_IDLE.id, world.getBlockMetadata(x, y, z));
+                world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TORCH_REDSTONE_IDLE.id(), world.getBlockMetadata(x, y, z));
             }
         } else if (!isPowered) {
-            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TORCH_REDSTONE_ACTIVE.id, world.getBlockMetadata(x, y, z));
+            world.setBlockAndMetadataWithNotify(x, y, z, Blocks.TORCH_REDSTONE_ACTIVE.id(), world.getBlockMetadata(x, y, z));
         }
     }
 
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
         super.onNeighborBlockChange(world, x, y, z, blockId);
-        world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+        world.scheduleBlockUpdate(x, y, z, id(), tickDelay());
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockTransparent.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTransparent.java
similarity index 51%
rename from game/core/src/main/java/net/minecraft/core/block/BlockTransparent.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicTransparent.java
index 9e3ee745b..d671696a3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockTransparent.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTransparent.java
@@ -2,12 +2,12 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 
-public class BlockTransparent extends Block
+public class BlockLogicTransparent extends BlockLogic
 {
 
-	public BlockTransparent(String key, String namespaceId, int id, Material material)
+	public BlockLogicTransparent(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
     }
 
     @Override
